@echo off
echo off
if '%KEEP%' == '1' prompt $p +k$g
:set ALLUSERSPROFILE=
set APPDATA=
set CommonProgramFiles=
set CommonProgramFiles(x86)=
set CommonProgramW6432=
set DriverData=
set FPS_BROWSER_APP_PROFILE_STRING=
set FPS_BROWSER_USER_PROFILE_STRING=
set FP_NO_HOST_CHECK=
set HOMEDRIVE=
set HOMEPATH=
set LOCALAPPDATA=
set LOGONSERVER=
set NUMBER_OF_PROCESSORS=
set OneDrive=
set PROCESSOR_IDENTIFIER=
set PROCESSOR_LEVEL=
set PROCESSOR_REVISION=
set ProgramData=
set ProgramFiles=
set ProgramFiles(x86)=
set ProgramW6432=
set PSModulePath=
set PUBLIC=
set SESSIONNAME=
set windows_tracing_flags=
set windows_tracing_logfile=
set COMPILER=
set OPTIONSBC=
set OPTIONSLC=
set OPTIONSGC=
set OPTIONSVC=
set LIBSBC=
set LIBSLC=
set LIBSGC=
set LIBSVC=
set BIT=
set WINDOWS=
set OPENMP=
if exist MkTcc.pif del MkTcc.pif
set BIT=16

if not "%PG%" == "" goto PG_OK
 echo/
 echo  Enviroment variable PG does not exist.
 echo/
 echo Execute this '%0'
 echo by 'mk.bat', 'm.bat' or something like that.
 set HIT=1
 goto EndOfBat
:PG_OK

if exist %PG%.c goto SrcOK
 echo/
 echo %PG%.c does not exist.
 set HIT=1
 goto EndOfBat
:SrcOK

set TCC_DIR=C:\APP16\TCC
if not "%PROCESSOR_ARCHITECTURE%" == "AMD64" goto SKIP_MSDOS
if exist %TOOLS%\msdos.exe goto MsDosOK
echo/
echo Error! %TOOLS%\msdos.exe does not exist.
echo/
echo Download from http://takeda-toshiya.my.coocan.jp/msdos/ .
echo And copy msdos\binary\i86_x86\msdos.exe to Pocom\tools .
echo/
set HIT=1
goto EndOfBat
:MsDosOk
:SKIP_MSDOS
if EXIST %TCC_DIR%\tcc.exe GOTO ComOK
echo/
echo Get Turbo-C, and copy to %TCC_DIR%
echo/
echo Then edit %TCC_DIR%\TURBOC.CFG
echo/
set HIT=1
GOTO EndOfBat
:ComOk
set MSDOS_PATH=%TCC_DIR%;%TOOLS%;%PATH%
PATH %TCC_DIR%;%TOOLS%;%PATH%

echo { %0 %BIT% bit C }

set OP=%OPTIONSTC% %OP%
if '%HIT%' == '1' set OP=%HIT_OPTIONS% %OP%
set OP=%OPTIONS% %OP%

if not '%ASM%' == '1' goto SkipAsm
if not "%PROCESSOR_ARCHITECTURE%" == "AMD64" goto NativeModeAsm
             echo msdos tcc -w -S -DMSDOS_EXE=1 %OP% %PG%.c
%TOOLS%\MSDOS %TCC_DIR%\tcc -w -S -DMSDOS_EXE=1 %OP% %PG%.c
goto EndOfBat
:NativeModeAsm
     echo tcc -S -w %OP% %PG%.c
%TCC_DIR%\tcc -S -w %OP% %PG%.c
goto EndOfBat
:SkipAsm

if exist %WINDIR%\find.exe set FIND=%WINDIR%\find.exe
if exist %WINDIR%\system\find.exe set FIND=%WINDIR%\system\find.exe
if exist %WINDIR%\system32\find.exe set FIND=%WINDIR%\system32\find.exe

if exist %EXE%.exe del %EXE%.exe
if not "%PROCESSOR_ARCHITECTURE%" == "AMD64" goto NativeMode
             echo msdos tcc -w -e$.exe -DMSDOS_EXE=1 %OP% %PG%.c %SUBSRCS% %LINKOPT% %LIBSTC%
%TOOLS%\msdos %TCC_DIR%\tcc -w -e$.exe -DMSDOS_EXE=1 %OP% %PG%.c %SUBSRCS% %LINKOPT% %LIBSTC%
if ERRORLEVEL 1 goto EndOfBat
if exist "%FIND%" dir $.exe | %FIND% "$"
   echo msdos -c%EXE%.exe $.exe
%TOOLS%\msdos -c%EXE%.exe $.exe
if ERRORLEVEL 1 set HIT=1
goto EndOfBat
:NativeMode
PATH %TCC_DIR%;%PATH%
     echo tcc -w -e%EXE%.exe %OP% %PG%.c %SUBSRCS% %LINKOPT% %LIBSTC%
%TCC_DIR%\tcc -w -e%EXE%.exe %OP% %PG%.c %SUBSRCS% %LINKOPT% %LIBSTC%
if ERRORLEVEL 1 goto EndOfBat
if exist "%FIND%" dir %EXE%.exe | %FIND% /I "%PG%" | %FIND% /I "exe"
:EndOfBat
if ERRORLEVEL 1 set HIT=1
if ERRORLEVEL 1 echo Failure
IF EXIST $.exe del $.exe
IF EXIST *.obj del *.obj
if '%HIT%' == '1' pause
