/*
test.c ver 2.09 ʂ̊mFEx`}[N
coded by isaku@pb4.so-net.ne.jp
*/
#if defined(_MSC_VER)
 #define _CRT_SECURE_NO_DEPRECATE
#endif
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#if defined(_M_IX86) || defined(_M_X64)
 #define WINDOWS_API__ 1
 #include <windows.h>
 #if !defined(NO_PERIOD)
  #include <mmsystem.h>
 #endif
#else
 #define WINDOWS_API__ 0
#endif
#if defined(SPLIT) && 3*SPLIT-1 == -3
 #include "zmtrand.h"
#elif defined(SPLIT) && SPLIT != 0
 #include "zmtrand.h"
#else
 #include "zmtrand.c"
#endif
#if defined(_MSC_VER) && INT_MAX > 32767
 #pragma comment(lib,"kernel32.lib")
 #pragma comment(lib,"user32.lib")
 #pragma comment(lib,"gdi32.lib")
 #if !defined(NO_PERIOD)
  #pragma comment(lib,"winmm.lib")
 #endif
#endif
#if defined(__unix__)
 #include <unistd.h>
 #include <sys/stat.h>
 #define mkdir(S) mkdir(S,0777)
#elif defined(__TURBOC__)
 #include <dir.h>
#else
 #include <direct.h>
 #if defined(_MSC_VER)
  #define mkdir _mkdir
 #endif
#endif

#if INT_MAX <= 32767 && !defined(PC9801) && defined(DOS__)
 #if defined(CLOCKS_PER_SEC)
  #undef CLOCKS_PER_SEC
 #endif
int32_t MyTick(void) {
    static long next,add,start; long prev; static char init_ok;
    do {
        prev=next;
        if (*(char far*)0x00400070L)
        { *(char far*)0x00400070L=0; add+=1573040L; }
        next=*(long far*)0x0040006cL+add;
    } while (prev!=next);
    if (init_ok==0) { init_ok=1; start=next; }
    return next-start;
}
 #define clock() MyTick()
 #define CLOCKS_PER_SEC 18.20648
#endif

#if WINDOWS_API__
  int32_t TimeTick__(void) {
      /* VC++2019 Core i3 4005U łP̎s 1.560 bB */
      /* timeGetTime()  2.960 bƔrƁAȂ荂B */
      /* timeGetTime() lAx͒ʏPT~bB*/
      /* timeBeginPeriod(1) s͂P~b */
      /* yEĐ\tgȂǂNP~bɂȂ邱Ƃ */
      uint64_t a; static uint64_t start;
      GetSystemTimeAsFileTime((FILETIME*)&a);
      if (start==0) start=a;
      return(int32_t)((a-start)/10000);
  }
 #define clock() TimeTick__()
 #if defined(CLOCKS_PER_SEC)
  #undef CLOCKS_PER_SEC
 #endif
 #define CLOCKS_PER_SEC 1000
#endif

/* TEST_TIME:P̌vԂ̖ڈ(b) */
#if !defined(TEST_TIME)
 #define TEST_TIME 1.5
#endif
 
/* TEST_NUM: ̉񐔌vČʂ͂̍ŏl */
#define TEST_NUM 8

/* INNER_LOOP:߂邽߂PɂP񎞊ԂBUȏs */
#define INNER_LOOP 10000U

/* MAX_LOOP:sƂ̖[v̉ */
#if defined(MSDOS_EXE)
 #define MAX_LOOP    10000000.0
#else
 #define MAX_LOOP 42949672960.0
#endif

#define TEST(FUNC,STR,SUM) \
int32_t i,z,a=clock(); unsigned j,k; double ret=1.0e10;\
printf("%-11s",STR); fflush(stdout);\
for (z=0;z<(int32_t)(MAX_LOOP/INNER_LOOP);z++) {\
 if (clock()-a>(int32_t)(0.5*TEST_TIME*CLOCKS_PER_SEC)) break;\
 for (j=0;j<INNER_LOOP;j++) SUM+=FUNC;\
}\
z+=z; if (z==0) z=1;\
 printf("%.2e",(double)z*INNER_LOOP); fflush(stdout);\
for (k=0;k<TEST_NUM;k++) {\
 double result=(double)clock()/CLOCKS_PER_SEC;\
 for (i=0;i<z;i++) {\
  for (j=0;j<INNER_LOOP;j++) SUM+=FUNC;\
 }\
 result=(double)clock()/CLOCKS_PER_SEC-result;\
 if (result>0&&result<ret) ret=result;\
 printf(" %5d",(int)(result*1000.0+0.5));\
 fflush(stdout);\
}\
ret=ret*(1.0e8/z/INNER_LOOP); printf("(%9.4f)\n",ret); fflush(stdout)

 /* O[oϐɍv߂鎖ŃIveB}CÛh */
uint32_t SumRand;
double   SumUnif;

double TestMt(void)  {TEST(NextMt(),  "NextMt()",  SumRand);return ret;}
double TestUnif(void){TEST(NextUnif(),"NextUnif()",SumUnif);return ret;}
 
FILE*fo;
char fname[280];
int Mode;
int UserChar;

char*StrUpr(char*s) {
    char*p=s;
    if (s==0) return 0;
    while (*p) { if (*p>='a'&&*p<='z') *p+=(char)('A'-'a'); p++; }
    return s;
}

void PutStr(const char*s) { fprintf(fo,"%s",s); }
void PutDbl(double x)     { fprintf(fo," %11.7f",x); }
void PutInt(int32_t x)    { fprintf(fo," %3ld",(long)x); }
void PutUsg(uint32_t x)   { fprintf(fo,"%10lu ",(unsigned long)x); }
void PutBit(int x)        { fprintf(fo,"%d",x); };
void PutLn1(const char*s) { fprintf(fo,"\r\n%-9s",s); }
void PutLn2(const char*s) { fprintf(fo,"%s\r\n",s); }
#if INT_MAX > 32767
 #if defined(_MSC_VER)||defined(__BORLANDC__)||\
   ( defined(__MINGW32__) && __GNUC__<= 9 )
void Put64(int64_t x) { fprintf(fo, "%24I64d",x); }
 #else
void Put64(int64_t x) { fprintf(fo, "%24lld",(long long)x); }
 #endif
#endif


void EachDist(int m)
{
    int i; static double vec[4];
    static uint32_t ini[4]={0x1234,0x5678,0x9abc,0xdef0};

    for (i=0;i<10000;i++) NextMt_m(m);
    PutLn1("Unif");
    for (i=0;i<4;i++) PutDbl(NextUnif_m(m));
    PutLn1("Int");
    for (i=0;i<12;i++) PutInt(NextInt_m(m,1000));
    PutLn1("IntEx");
    for (i=0;i<12;i++) PutInt(NextIntEx_m(m,1000));
    PutLn1("Chisq");
    for (i=0;i<4;i++) PutDbl(NextChisq_m(m,10));
    PutLn1("Gamma");
    for (i=0;i<4;i++) PutDbl(NextGamma_m(m,10));
    PutLn1("Geometric");
    for (i=0;i<12;i++) PutInt(NextGeometric_m(m,0.2));
    PutLn1("Triangle");
    for (i=0;i<4;i++) PutDbl(NextTriangle_m(m));
    PutLn1("Exp");
    for (i=0;i<4;i++) PutDbl(NextExp_m(m));
    PutLn1("Normal");
    for (i=0;i<4;i++) PutDbl(NextNormal_m(m));
    PutLn1("UnitVect"); NextUnitVect_m(m,vec,4);
    for (i=0;i<4;i++) PutDbl(vec[i]);
    PutLn1("Binomial");
    for (i=0;i<12;i++) PutInt(NextBinomial_m(m,10,0.3));
    PutLn1("Binormal");
    for (i=0;i<4;i+=2) NextBinormal_m(m,0.3,vec+i,vec+i+1);
    for (i=0;i<4;i++) PutDbl(vec[i]);
    PutLn1("Beta");
    for (i=0;i<4;i++) PutDbl(NextBeta_m(m,2.0,3.0));
    PutLn1("Power");
    for (i=0;i<4;i++) PutDbl(NextPower_m(m,10));
    PutLn1("Logistic");
    for (i=0;i<4;i++) PutDbl(NextLogistic_m(m));
    PutLn1("Cauchy");
    for (i=0;i<4;i++) PutDbl(NextCauchy_m(m));
    PutLn1("FDist");
    for (i=0;i<4;i++) PutDbl(NextFDist_m(m,10,20));
    PutLn1("Poisson");
    for (i=0;i<12;i++) PutInt(NextPoisson_m(m,2.0));
    PutLn1("TDist");
    for (i=0;i<4;i++) PutDbl(NextTDist_m(m,10));
    PutLn1("Weibull");
    for (i=0;i<4;i++) PutDbl(NextWeibull_m(m,0.3));
    PutLn1("Bit");
    for (i=0;i<48;i++) fprintf(fo,"%d",(int)NextBit_m(m));
    PutLn1("Byte");
    for (i=0;i<12;i++) fprintf(fo," %3d",(int)NextByte_m(m));
#if INT_MAX > 32767
    PutLn1("NextMt64");
    for (i=0;i<2;i++) Put64(NextMt64_m(m));
#endif
    PutLn1("Init"); InitMt_m(m,1234);
    for (i=0;i<4;i++) PutDbl(NextUnif_m(m));
    PutLn1("InitEx"); InitMtEx_m(m,ini,4);
    for (i=0;i<4;i++) PutDbl(NextUnif_m(m));
    PutLn2("");
}

void TestOutSub(const char*name) {
    int i;
    fo=fopen(name,"wb");
    if (fo==0) { printf("Cannot open '%s'.\n",name); exit(1); }
    fprintf(fo,"1000 outputs of genrand_int32()\r\n");
    for (i=0;i<1000;i++) {
        fprintf(fo,"%10lu ",(unsigned long)NextMt());
        if (i%5==4) fprintf(fo,"\r\n");
    }
    fprintf(fo,"\r\n1000 outputs of genrand_real2()\r\n");
    for (i=0;i<1000;i++) {
        fprintf(fo,"%10.8f ", NextMt()*(1.0/4294967296.0));
        if (i%5==4) fprintf(fo,"\r\n");
    }
    fclose(fo);
}

void TestOut(void)
{       
    uint32_t ini[]={0x123, 0x234, 0x345, 0x456};

    InitMtEx(ini,4);
#if defined(DUAL)
    if (DefaultMt->flag) sprintf(fname,"C/c%dx.txt",MEXP); else
#endif
#if defined(ORIGINAL) && defined(MAG) && \
   !defined(STABLE_SPEED) && !defined(UNIF_52)&&!defined(FAST_UNIF)
    sprintf(fname,"C/c%do-.txt",MEXP);
#else
    sprintf(fname,"C/c%do.txt",MEXP);
#endif
    TestOutSub(fname);
    printf("'%s'  ",fname);
#if defined(DUAL)
    if (DefaultMt->flag) {
        int save=DefaultMt->flag;
        sprintf(fname,"C/c%do.txt",MEXP);
        InitMtEx(ini,4);
        DefaultMt->flag=0;
        TestOutSub(fname);
        printf("'%s'  ",fname);
        DefaultMt->flag=save;
    }
#endif
}

#if defined(LSI_C)
 #if defined(MSDOS_EXE)
  #define COMP "LCC-DOS  "
 #else
  #define COMP "LCC      "
 #endif
#elif defined(__BORLANDC__)
 #define COMP "BorlandC "
#elif defined(__TURBOC__)
 #if defined(MSDOS_EXE)
  #define COMP "TCC-DOS  "
 #else
  #define COMP "TCC      "
 #endif
#elif defined(__GNUC__)
 #define STR(X) #X
 #define GNU(X) STR(X)
 #if __GNUC__ <= 9
  #define GNUV GNU(__GNUC__) "  "
 #else
  #define GNUV GNU(__GNUC__) " "
 #endif
 #if defined(__MINGW32__)
  #define COMP "TdmGcc" GNUV
 #else
  #define COMP "UniGcc" GNUV
 #endif
#elif defined(_MSC_VER) && _MSC_VER >= 1100 && _MSC_VER < 1200
 #define COMP "VC++50   "
#elif defined(_MSC_VER) && _MSC_VER >= 1200 && _MSC_VER < 1300
 #define COMP "VC++60   "
#elif defined(_MSC_VER) && _MSC_VER >= 1300 && _MSC_VER < 1310
 #define COMP "VC++2002 "
#elif defined(_MSC_VER) && _MSC_VER >= 1310 && _MSC_VER < 1400
 #define COMP "VC++2003 "
#elif defined(_MSC_VER) && _MSC_VER >= 1400 && _MSC_VER < 1500
 #define COMP "VC++2005 "
#elif defined(_MSC_VER) && _MSC_VER >= 1500 && _MSC_VER < 1600
 #define COMP "VC++2008 "
#elif defined(_MSC_VER) && _MSC_VER >= 1600 && _MSC_VER < 1700
 #define COMP "VC++2010 "
#elif defined(_MSC_VER) && _MSC_VER >= 1700 && _MSC_VER < 1800
 #define COMP "VC++2012 "
#elif defined(_MSC_VER) && _MSC_VER >= 1800 && _MSC_VER < 1900
 #define COMP "VC++2013 "
#elif defined(_MSC_VER) && _MSC_VER >= 1900 && _MSC_VER < 1910
 #define COMP "VC++2015 "
#elif defined(_MSC_VER) && _MSC_VER >= 1910 && _MSC_VER < 1920
 #define COMP "VC++2017 "
#elif defined(_MSC_VER) && _MSC_VER >= 1920 && _MSC_VER < 1930
 #define COMP "VC++2019 "
#elif defined(_MSC_VER) && _MSC_VER >= 1930 && _MSC_VER < 1940
 #define COMP "VC++2022 "
#else
#define COMP "UNKNOWN  "
#endif

#if defined(FAST_UNIF)
 #define RES "32"
#elif ( ( defined(ORIGINAL) && !defined(STABLE_SPEED) ) || \
          defined(OLD_UNIF) ) && !defined(UNIF_52)
 #define RES "53"
#elif ( ( INT_MAX<=32767 && !defined(UNIF_53) ) || defined(UNIF_52) ) \
       && !defined(NOT_IEEE754__)
 #define RES "52"
#else
 #define RES "53"
#endif

#if defined(__cplusplus)
 #define CPP "C++ "
#else
 #define CPP "C   "
#endif

#if defined(STABLE_SPEED) || defined(ORIGINAL)
 #define EX "SMALL   "
#elif defined(EXTEND)
 #define EX "EXTEND  "
#elif defined(COMPACT)
 #define EX "COMPACT "
#else
 #define EX "SMALL   "
#endif

#if defined(STABLE_SPEED)
 #define DS "STBL "
#elif defined(ORIGINAL)
 #define DS "ORIG "
#elif INT_MAX <= 32767
 #define DS "8086 "
#elif defined(DUAL) && defined(HAVE_SIMD)
 #define DS "DUAL "
#else
 #define DS "ONLY "
#endif

#if defined(MAG)
 #define FTYPE "MAG"
#elif defined(NEG)
 #define FTYPE "NEG"
#elif defined(SLR)
 #define FTYPE "SLR"
#elif defined(MUL)
 #define FTYPE "MUL"
#elif defined(CND)
 #define FTYPE "CND"
#endif

#if defined(DUAL) && defined(HAVE_SIMD)
 #if defined(AVX2)
const char*DualType[2]={DS FTYPE,DS "AVX2"};
 #elif defined(SSE3)
const char*DualType[2]={DS FTYPE,DS "SSE3"};
 #elif defined(SSE2)
const char*DualType[2]={DS FTYPE,DS "SSE2"};
 #endif
 #define ZTYPE DualType[DefaultMt->flag]
#elif defined(HAVE_AVX2)
 #define ZTYPE DS "AVX2"
#elif defined(HAVE_SSE3)
 #define ZTYPE DS "SSE3"
#elif defined(HAVE_SSE2)
 #define ZTYPE DS "SSE2"
#else
 #define ZTYPE DS FTYPE
#endif

#if defined(STABLE_SPEED) || defined(ORIGINAL)
 #define SM       "SIMPLE "
#elif defined(DUAL)
 #if (  defined(HAVE_AVX2) && defined(SIMPLE256GEN) ) || \
     ( !defined(HAVE_AVX2) && defined(SIMPLE128GEN) )
  #define SM_SIMD "SIMPLE "
 #else
  #define SM_SIMD "UNROLL "
 #endif
 #if defined(SIMPLE32GEN)
  #define SM_i386   "SIMPLE "
 #else
  #define SM_i386   "UNROLL "
 #endif
 const char*sm_str[]={SM_i386,SM_SIMD};
 #define SM sm_str[DefaultMt->flag!=0]
#elif defined(HAVE_SIMD)
 #if (  defined(HAVE_AVX2) && defined(SIMPLE256GEN) ) || \
     ( !defined(HAVE_AVX2) && defined(SIMPLE128GEN) )
  #define SM "SIMPLE "
 #else
  #define SM "UNROLL "
 #endif
#elif INT_MAX <= 32767
 #if defined(SIMPLE16GEN)
  #define SM "SIMPLE "
 #else
  #define SM "UNROLL "
 #endif
#else
 #if defined(SIMPLE32GEN)
  #define SM "SIMPLE "
 #else
  #define SM "UNROLL "
 #endif
#endif

#if defined(NextMt)
 #define DI "MACRO  "
#else
 #define DI "DIRECT "
#endif

void TestSpeed(void) {       
#if defined(__unix__)
    static char buf[256];
#endif
    double rm,ru; const char*p;
#if defined(DOS__)
    static char quote[32];
#else 
    static char quote[268];
#endif 
#if WINDOWS_API__ && !defined(NO_PERIOD)
    timeBeginPeriod(1);
#endif
    if (Mode==2) {
#if defined(__unix__)
        gethostname(buf,sizeof buf); p=StrUpr(buf);
#else    
        p=StrUpr(getenv("USERDOMAIN"));
#endif
        if (p==0) p="UNKNOWN";
        if (UserChar=='%') {
#if defined(DOS__)
            sprintf(fname,"%c%.7s.TXT",UserChar,p);
#else
            sprintf(fname,"%c%.256s.TXT",UserChar,p);
#endif
        } else {
#if defined(DOS__)
            sprintf(fname,"C/%c%.7s.TXT",UserChar,p);
#else
            sprintf(fname,"C/%c%.256s.TXT",UserChar,p);
#endif
        }
        sprintf(quote," '%.263s'",fname);
    }
    printf("v%d.%02d %-5d " COMP CPP "%-9s " EX "%s" DI "%d " RES "%s\n",
        __ZMTRAND__/100,__ZMTRAND__%100,MEXP,ZTYPE,SM,(int)sizeof(int*)*8,
        Mode==2?quote:"");
    rm=TestMt(); ru=TestUnif();
    if (Mode==2) {
        fo=fopen(fname,"ab");
        if (fo==0) { printf("Cannot open '%s'.\n",fname); exit(1); }
        fprintf(fo,
         "%-5d " COMP CPP "%-9s " EX "%s" DI "%d " RES " %8.4f %9.4f\r\n",
          MEXP,ZTYPE,SM,(int)sizeof(int*)*8,rm,ru);
        fclose(fo);
    }
#if WINDOWS_API__ && !defined(NO_PERIOD)
    timeEndPeriod(1);
#endif
}

int main(int argc,char**argv) {
    int m;
#if !defined(WIN__) && !defined(DOS__) && !defined(__BYTE_ORDER__)
    int endian=1;
 #if defined(BIG_E)
    if (*((char*)&endian)) {
        printf("The system is little endian. But defined 'BIG_E'");
        return 1;
    }
 #else
    if ((*((char*)&endian)==0)) {
        printf("The system is big endian. But not defined 'BIG_E'");
        return 1;
    }
 #endif
#endif
#if !defined(DUAL) && !defined(ORIGINAL) && !defined(STABLE_SPEED)
 #if defined(HAVE_AVX2)
    if (CpuType()<3) { printf("\n Error:No AVX2\n"); exit(0); }
 #elif defined(HAVE_SSE3)
    if (CpuType()<2) { printf("\n Error:No SSE3\n"); exit(0); }
 #elif defined(HAVE_SSE2)
    if (CpuType()<1) { printf("\n Error:No SSE2\n"); exit(0); }
 #endif
#endif
    (void)mkdir("C");
    if      (argc==2&&argv[1][0]=='-') Mode=1;
    else if (argc==2&&argv[1][0]=='+') { Mode=2; UserChar=argv[1][1]; }
    else Mode=0;
    if (UserChar==0) UserChar='%';
    InitMt(1);
    if (Mode==0) {    
       printf("v%d.%02d %-5d " COMP CPP "%-9s " EX "%s" DI "%d " RES "\n",
         __ZMTRAND__/100,__ZMTRAND__%100,MEXP,ZTYPE,SM,(int)sizeof(int*)*8);
#if defined(ORIGINAL) && defined(MAG) && \
   !defined(STABLE_SPEED) && !defined(UNIF_52)&&!defined(FAST_UNIF)
        sprintf(fname,"C/c%dd-.txt",MEXP);
#else
        sprintf(fname,"C/c%dd.txt",MEXP);
#endif
        fo=fopen(fname,"wb");
        if (fo==0) { printf("Cannot open '%s'.\n",fname); exit(1); }
        for (m=0;m<(MSEQ>4?4:MSEQ);m++)  EachDist(m);
        fclose(fo);
        printf("'%s'  ",fname);
        TestOut();
        printf("\n");
    } else {
#if defined(HAVE_SIMD)
        if (DefaultMt->flag) TestSpeed();
 #if defined(DUAL)
        DefaultMt->flag=0;
        TestSpeed();
 #endif
#else
        DefaultMt->flag=0;
        TestSpeed();
#endif
    }
#if defined(HIT_ENTER)
    fprintf(stderr," > "); fflush(stderr); fgetc(stdin);
#endif
    return 0;
}
