@echo off
echo off
if '%KEEP%' == '1' prompt $p +k$g
if exist Mk2003.pif del Mk2003.pif
set BIT=32

if not "%PG%" == "" goto PG_OK
 echo/
 echo  Enviroment variable PG does not exist.
 echo/
 echo Execute this '%0'
 echo by 'mk.bat', 'm.bat' or something like that.
 set HIT=1
 goto EndOfBat
:PG_OK

if not '%CPP%' == '1' goto SrcC
 if exist %PG%.cpp set PG2=/TP %PG%.cpp
 if exist %PG%.cpp goto SrcOK
 if exist %PG%.c set PG2=/TP %PG%.c
 if exist %PG%.c goto SrcOK
  echo/
  echo Neither %PG%.c nor %PG%.cpp does exist
  set HIT=1
  goto EndOfBat
:SrcC
  if exist %PG%.c set PG2=%PG%.c
  if exist %PG%.c goto SrcOK
  echo/
  echo %PG%.c does not exist.
  set HIT=1
  goto EndOfBat
:SrcOK

set VS=C:\Program Files ^(x86^)\Microsoft Visual Studio .NET 2003
if exist "%VS%\VC7\BIN\CL.EXE" goto ComOK
set VS=C:\Program Files\Microsoft Visual Studio .NET 2003
if exist "%VS%\VC7\BIN\CL.EXE" goto ComOK
echo/
echo %VS%\VC7\BIN\CL.EXE is not found.
echo Please install Visual C++ 2003
 set HIT=1
goto EndOfBat
:ComOK
set SDK=%VS%\VC7\PlatformSDK
PATH %VS%\Common7\IDE;%VS%\VC7\BIN;%PATH%
set INCLUDE=%VS%\VC7\INCLUDE;%SDK%\include
set LIB=%VS%\VC7\LIB;%SDK%\lib

if     '%CPP%' == '1' echo { %0 %BIT% bit C++ }
if not '%CPP%' == '1' echo { %0 %BIT% bit C }

set OP=%OPTIONSVC% %OP%
if '%HIT%' == '1' set OP=%HIT_OPTIONS% %OP%
set OP=%OPTIONS% %OP%
if not '%WINDOWS%' == '1' set WINDOWS=0
if     '%WINDOWS%' == '1' set OP=-DWINDOWS %OP%

if not '%ASM%' == '1' goto SkipAsm
              echo cl /nologo /Fa /c /W4 /MT %OP% /GL- %PG2%
"%VS%\VC7\BIN\CL.EXE" /nologo /Fa /c /W4 /MT %OP% /GL- %PG2%
goto SkipC
:SkipAsm

if     exist %PG%.rc               echo rc /fotemp.res %PG%.rc
if     exist %PG%.rc "%VS%\VC7\BIN\RC.EXE" /fotemp.res %PG%.rc
if not exist %PG%.rc call %TOOLS%\AddVer.bat
if not exist %PG%.rc               echo rc temp.rc
if not exist %PG%.rc "%VS%\VC7\BIN\RC.EXE" temp.rc
if ERRORLEVEL 1 goto SkipC

if exist %EXE%.exe del %EXE%.exe
              echo cl /nologo /Fe%EXE%.exe /W4 /MT %OP% %PG2% %SUBSRCS% /link /IGNORE:4068 %LINKOPT% %LIBSVC% temp.res kernel32.lib user32.lib gdi32.lib comdlg32.lib winmm.lib imm32.lib wininet.lib shell32.lib advapi32.lib comctl32.lib iphlpapi.lib
"%VS%\VC7\BIN\CL.EXE" /nologo /Fe%EXE%.exe /W4 /MT %OP% %PG2% %SUBSRCS% /link /IGNORE:4068 %LINKOPT% %LIBSVC% temp.res kernel32.lib user32.lib gdi32.lib comdlg32.lib winmm.lib imm32.lib wininet.lib shell32.lib advapi32.lib comctl32.lib iphlpapi.lib

:SkipC
if ERRORLEVEL 1 set HIT=1
if exist *.obj del *.obj
if exist temp.res del temp.res
if exist temp.rc del temp.rc
if exist RCa????? del RCa?????
if exist vc70.idb del vc70.idb
if exist *.tlh del *.tlh
if exist *.tli del *.tli

:EndOfBat
if '%HIT%' == '1' pause
