@echo off
echo off
if '%KEEP%' == '1' prompt $p +k$g
:set ALLUSERSPROFILE=
set APPDATA=
set CommonProgramFiles=
set CommonProgramFiles(x86)=
set CommonProgramW6432=
set DriverData=
set FPS_BROWSER_APP_PROFILE_STRING=
set FPS_BROWSER_USER_PROFILE_STRING=
set FP_NO_HOST_CHECK=
set HOMEDRIVE=
set HOMEPATH=
set LOCALAPPDATA=
set LOGONSERVER=
set NUMBER_OF_PROCESSORS=
set OneDrive=
set PROCESSOR_IDENTIFIER=
set PROCESSOR_LEVEL=
set PROCESSOR_REVISION=
set ProgramData=
set ProgramFiles=
set ProgramFiles(x86)=
set ProgramW6432=
set PSModulePath=
set PUBLIC=
set SESSIONNAME=
set windows_tracing_flags=
set windows_tracing_logfile=
set COMPILER=
set BIT=
set WINDOWS=
set OPENMP=
set OPTIONSBC=
set OPTIONSTC=
set OPTIONSGC=
set OPTIONSVC=
set LIBSBC=
set LIBSTC=
set LIBSGC=
set LIBSVC=
if exist MkLcc.pif del MkLcc.piif
set BIT=16

if not "%PG%" == "" goto PG_OK
 echo/
 echo  Enviroment variable PG does not exist.
 echo/
 echo Execute this '%0'
 echo by 'mk.bat', 'm.bat' or something like that.
 set HIT=1
 goto EndOfBat
:PG_OK

if exist %PG%.c goto SrcOK
 echo/
 echo %PG%.c does not exist.
 set HIT=1
 goto EndOfBat
:SrcOK

set LCC_DIR=C:\APP16\LSIC86
if not "%PROCESSOR_ARCHITECTURE%" == "AMD64" goto SKIP_MSDOS
if exist %TOOLS%\msdos.exe goto MsDosOK
echo/
echo Error! %TOOLS%\msdos.exe does not exist.
echo/
echo Download from http://takeda-toshiya.my.coocan.jp/msdos/ .
echo And copy msdos\binary\i86_x86\msdos.exe to Pocom\tools .
echo/
set HIT=1
goto EndOfBat
:MsDosOk
:SKIP_MSDOS
if EXIST %LCC_DIR%\BIN\lcc.exe GOTO ComOK
echo/echo Download LSI-C from http://www.lsi-j.co.jp/freesoft/
echo/
echo And copy to %LCC_DIR% .
echo And edit %LCC_DIR%\BIN\_LCC .
echo/
set HIT=1
GOTO EndOfBat
:ComOk
set MSDOS_PATH=%LCC_DIR%\BIN;%TOOLS%;%PATH%
PATH %LCC_DIR%\BIN;%TOOLS%;%PATH%

echo { %0 %BIT% bit C }

set OP=%OPTIONSLC% %OP%
if '%HIT%' == '1' set OP=%HIT_OPTIONS% %OP%
set OP=%OPTIONS% %OP%

if not '%ASM%' == '1' goto SkipAsm
if not "%PROCESSOR_ARCHITECTURE%" == "AMD64" goto NativeModeAsm
                 echo msdos lcc -S -DMSDOS_EXE=1 %OP% %PG%.c
%TOOLS%\MSDOS %LCC_DIR%\BIN\lcc -S -DMSDOS_EXE=1 %OP% %PG%.c
goto EndOfBat
:NativeModeAsm
         echo lcc -S %OP% %PG%.c
%LCC_DIR%\BIN\lcc -S %OP% %PG%.c
goto EndOfBat
:SkipAsm

if exist %WINDIR%\find.exe set FIND=%WINDIR%\find.exe
if exist %WINDIR%\system\find.exe set FIND=%WINDIR%\system\find.exe
if exist %WINDIR%\system32\find.exe set FIND=%WINDIR%\system32\find.exe

echo Please wait...
if exist %EXE%.exe del %EXE%.exe
if not "%PROCESSOR_ARCHITECTURE%" == "AMD64" goto NativeMode
                 echo msdos lcc -o $.exe -DMSDOS_EXE %OP% %PG%.c %SUBSRCS% %LINKOPT% %LIBSLC% -lmathlib
%TOOLS%\msdos %LCC_DIR%\BIN\lcc -o $.exe -DMSDOS_EXE %OP% %PG%.c %SUBSRCS% %LINKOPT% %LIBSLC% -lmathlib
if ERRORLEVEL 1 goto EndOfBat
if exist "%FIND%" dir $.exe | %FIND% "$"
echo    msdos -c%EXE%.exe $.exe
%TOOLS%\msdos -c%EXE%.exe $.exe
goto EndOfBat
:NativeMode
path %LCC_DIR%\BIN
         echo lcc -o %EXE%.exe %OP% %PG%.c %SUBSRCS% %LINKOPT% %LIBSLC% -lmathlib
%LCC_DIR%\BIN\lcc -o %EXE%.exe %OP% %PG%.c %SUBSRCS% %LINKOPT% %LIBSLC% -lmathlib
if ERRORLEVEL 1 goto EndOfBat
if exist "%FIND%" dir %EXE%.exe | %FIND% /I "%PG%" | %FIND% /I "exe"
:EndOfBat
if ERRORLEVEL 1 set HIT=1
IF EXIST $.exe del $.exe
IF EXIST *.obj del *.obj
if '%HIT%' == '1' pause
